;******************************************************************************
;@Free386 macro
;******************************************************************************
;
;
%imacro	PRINT86	1
	mov	dx,%1
	mov	ah,09h
	int	21h
%endmacro

%imacro	PRINT	1
	mov	edx,%1
	mov	ah,09h
	int	21h
%endmacro

%imacro	PRINT_	1
	push	eax
	push	edx
	mov	edx,%1
	mov	ah,09h
	int	21h
	pop	edx
	pop	eax
%endmacro

%imacro	PRINT_crlf	0
	mov	ah,02h
	mov	dl,13
	int	21h
	mov	dl,10
	int	21h
%endmacro

%imacro	Program_end	1	;***** vZXI *****
	mov	ah,4ch
	mov	al,%1
	int	21h	;I
%endmacro

%imacro getvecter	0	;xN^AhX擾 > ES:BX
	mov	ah,35h
	mov	al,Interrupt_No	;` Int ԍ
	int	21h
%endmacro

%imacro	setvecter	0	;xN^AhXݒ < DS:DX
	mov	ah,25h
	mov	al,Interrupt_No	;` Int ԍ
	int	21h
%endmacro

;******************************************************************************
;F386 p}N
;******************************************************************************
;------------------------------------------------------------------------------
;EXMS Driver  call }N
;------------------------------------------------------------------------------
%macro	XMS_function	0
	call	far [XMS_entry]		;XMS far call
%endmacro


;------------------------------------------------------------------------------
;EF386 ̃veNg[hI
;------------------------------------------------------------------------------
%macro	F386_end	1
	mov	b [f386err],%1		;G[ԍL^
	jmp	END_program
%endmacro

;------------------------------------------------------------------------------
;EV86  int 𔭌}N
;------------------------------------------------------------------------------
%macro	V86_INT	1
	pushf
	push	cs
	push	d (offset .ret_label)
	push	d %1*4			;intԍ *4
	jmp	call_V86_int

	align	4
.ret_label:
%endmacro

%macro	V86_INT_21h	0
	pushf
	push	cs
	call	call_V86_int21
%endmacro

;------------------------------------------------------------------------------
;EV86 ̊荞݂𔻕ʂ}Nigp / VCPIp͕svj
;------------------------------------------------------------------------------
;%macro	check_int_from_V86	0
;	test	b [esp+10],02h		;+08h ɂ EFLAGS  VMrbg
;	jnz	near int_from_V86	;V86[h̊荞ݐp[`
;%endmacro

;------------------------------------------------------------------------------
;EL[NA & L[Zbg
;------------------------------------------------------------------------------
%imacro	set_cy	0	;Carry set
	or	b [esp+8], 01h	;Carry Zbg
%endmacro

%imacro	clear_cy 0	;Carry reset
	and	b [esp+8],0feh	;Carry NA
%endmacro

save_cy:	;
cy_save:	;Ah~[u
cy_set:		;
cy_clear:	;

;------------------------------------------------------------------------------
;EL[̏ԂZ[u iret }N
;------------------------------------------------------------------------------
%imacro	iret_save_cy	0	;Cy Z[u iretd 
	jc	.__set_cy
	clear_cy
	iret
.__set_cy:
	set_cy
	iret
%endmacro

;------------------------------------------------------------------------------
;EINT Ăяô悤Ƀx call }N
;------------------------------------------------------------------------------
%imacro	calli	1	;Cy Z[u iretd 
	pushf
	push	cs
	call	%1
%endmacro

;------------------------------------------------------------------------------
;EWX^_v
;------------------------------------------------------------------------------
%imacro call_RegisterDump_with_code	1
	mov	d [dump_err_code], %1
	call	register_dump		;safe
%endmacro
;------------------------------------------------------------------------------
;EINTpWX^_v
;------------------------------------------------------------------------------
%imacro call_RegisterDumpInt	1
%if INT_HOOK
	push	d %1
	call	register_dump_from_int	;safe
	mov	[esp], eax
	pop	eax
%endif
%endmacro

;******************************************************************************
;fBoOp}N
;******************************************************************************

%imacro	SPEED_N		0	;fBoOp > ݊[hؑւ
	push	dx
	push	ax
	mov	dx,5ech
	xor	al,al
	out	dx,al
	pop	ax
	pop	dx
%endmacro

%imacro	PAD_WAIT	0	;fBoOp > ݊[hؑւ
	push	eax
	push	edx
	push	ebp

	mov	dx,4d0h
._off	in	al,dx
	test	al,10h
	jz	._off

._on	in	al,dx
	dec	ebp
	test	al,10h
	jnz	._on

	pop	ebp
	pop	edx
	pop	eax
%endmacro


%macro	FAULT	0	;fBoOp / یG[
	mov	[offset -1],eax
%endmacro


