;******************************************************************************
;@Free386	veNg[h
;******************************************************************************
;
; 2001/02/11 TOWNS-OS p̏
; 2016/12/20 CoCoΉ
; 2020/12/28 386SXΉ

BITS	16
;==============================================================================
;TOWNS ȈՃ`FbN
;==============================================================================
;Ret	Cy=0	TOWNS Ȃ
;	Cy=1	TOWNS łȂ?
;
	align	4
check_TOWNS:
	in	al,30h		;CPU ʃWX^
	test	al,al		;=and^l check
	jz	.not_fm		;0 Ȃ FM V[YłȂ
	inc	al		;+1 
	jz	.not_fm		;0ffh ł FM V[YłȂ(FM16Ŏ邗)

	;FM  TOWNS??
	mov	dx,020eh	;hCuXCb`WX^(TOWNS ̂)
	in	al,dx		;FD  OtFD ł
	and	al,0feh		;bit 7`1  and 
	jnz	.not_TOWNS	;all 0 łȂ TOWNS ł͂Ȃ

	clc	;
	ret

.not_fm:
.not_TOWNS:
	stc	;s
	ret

;==============================================================================
;CoCo̕ۑ
;==============================================================================
; CALLobt@ɕۑ
	align	4
init_TOWNS:
	;
	; VCPI񂩂瑍eʂ̏C
	;
	xor	eax, eax
	mov	dx, 5e8h	; eʃWX^iɂ͂Ȃj
	in	al, 30h		; @IDWX^̂CPU擾
	mov	ah, al		; CPU ah ɑޔ
	in	al, dx		; al MB
	cmp	ah, 02h		; CPU`FbN
	je	.ok		; 486ȏȂbit7̓eʂ̈ꕔƂĈ
	test	al,80h		; 386fł̓eʃWX^L check
	je	.ok		; eʃWX^L(bit7=0)Ȃ .ok 
	mov	al, 06h		; eʃWX^Ȃꍇ 6MB Œ
.ok:
	shl	ax, 8		; MB to pages (eax̏24bit͍lȂ)
	mov	[all_mem_pages], eax	; ŃXg[邩
	call	init_CoCo
	ret

;==============================================================================
;CoCo̕ۑ
;==============================================================================
; CALLobt@ɕۑ
	align	4
init_CoCo:
	mov	ax, 0c000h	; CoCo݊mF
	int	8eh
	test	ah, ah
	jnz	.fail

	cmp	bh, 32h
	jb	.fail
	cmp	cx, 436fh	; 'Co'
	jne	.fail
	cmp	dx, 436fh	; 'Co'
	jne	.fail
	cmp	si, 204bh	; ' K'
	jne	.fail
	cmp	di, 656eh	; 'en'
	jne	.fail

	xor	bp, bp			; counter
	mov	si, [callbuf_adr16]
	mov	es, [callbuf_seg16]
	mov	di, offset nsdd_selectors
.loop:
	push	di
	mov	cx, bp
	mov	di, [work_adr]	  	; offset
	mov	ax, 0c103h
	int	8eh
	pop	di

	test	ah, ah
	jnz	.end

	; CS save to [nsdd_selectors]
	mov	[di], bx
	add	di, 2

	; ZOg^f[^̌`ϊ
	push	di
	mov	di, [work_adr]		; offset
	call	segdata_to_seglist
	add	di, 8
	mov	bx, dx
	call	segdata_to_seglist
	pop	di

	inc	bp
	cmp	bp, cx
	jae	.end
	cmp	bp, NSDD_max	;Œ 1KB Ȃ̂ōő 64 Gg܂
	jb	.loop
.end:
	xor	eax, eax
	mov	[es:si], eax	; end mark
.fail:
	mov	ax, ds
	mov	es, ax
	ret


	align	4
	;----------------------------------------------------
	; ZOg`̃f[^̉H
	;----------------------------------------------------
	; (example) Seg-Reg` /  limit  byte
	; FF 7F 00 80  21 9A 40 00 - FF 7F 00 80  21 92 40 00
	; 4C 00 00 00  00 00 00 00 - 44 00 00 00  00 00 00 00
segdata_to_seglist:
	; in=[di]  out=[es:si]
	;----------------------------------------------------
	; ړǏ`
	;----------------------------------------------------
	; dd	selector
	; dd	physical address
	; dd	pages-1
	; dd	type/level
	xor	eax, eax
	mov	 ax,  bx
	mov	[es:si],eax	; selector

	; di, dxj

	mov	ah, [di+6]	; type and limit - bit
	test	ah, 40h		; 32bit seg?
	jz	.skip		; if 16bit seg jump

	and	ah, 00fh
	shl	eax, 8
	mov	ax, [di]	; limit
	mov	[es:si+8],eax

	mov	ah, [di+7]
	mov	al, [di+4]
	shl	eax, 16
	mov	ax, [di+2]
	mov	[es:si+4],eax	; base

	xor	eax, eax
	mov	al, [di+5]
	mov	ah, al
	and	al, 01100000b
	and	ah, 00001110b
	shr	al, 5
	mov	[es:si+12],eax
	add	si, 10h
.skip:
	ret


BITS	32
;==============================================================================
;T-OS ̃ݒ
;==============================================================================
	align	4
setup_TOWNS:
	push	es
	in	al, 30h
	cmp	al, 03h			; 386SX
	je	.setup_memory_386sx
.setup_memory_386dx:
	mov	ebx,offset T_OS_memory_map	;̃}bv(386DX/486/Pentium)
	jmp	.setup
.setup_memory_386sx:
	mov	ebx,offset T_OS_memory_map_386sx	;̃}bv(386SX)
.setup:
	call	map_memory			;
	mov	esi,offset T_OS_selector_alias	;GCAX̍쐬
	call	make_aliases			;

	;------------------------------------------
	;T-BIOS ̒ / thanks to Mamiya (san)
	;------------------------------------------
	;port(0x3b90) TBIOSAhX
	;port(0x3b98) TBIOSTCY
	;port(0x3ad0) TBIOS[NAhX(512byte)

	mov	dx,3b90h		;T-BIOS x[XAhXǂݏo
	call	TOWNS_CMOS_READ		;ebx <- READ
	mov	esi,ebx			;esi = address

	mov	dx,3b98h		;T-BIOS TCYǂݏo
	call	TOWNS_CMOS_READ		;ebx <- READ
	dec	ebx			;ebx = limit

	;/// ZN^쐬 //////
	mov	edi,[work_adr]		;[N
	mov	d [edi  ],esi		;base
	mov	d [edi+4],ebx		;limit

	mov	d [edi+8],0a00h		;R/X / x=0
	mov	eax,TBIOS_cs		;SANZXZN^
	call	make_mems		;ZN^쐬 edi=\ eax=sel

	mov	d [edi+8],0200h		;R/W / x=0
	mov	eax,TBIOS_ds		;SANZXZN^
	call	make_mems		;ZN^쐬 edi=\ eax=sel

	;------------------------------------------
	;VRAM̏`FbNp̒l
	;------------------------------------------
	mov	ebx, 128h
	mov	es, bx
	mov	d [es:07fffch], 011011011h

	;------------------------------------------
	;NSDD
	;------------------------------------------
	cmp	b [nsdd_load], 0
	jz	short .no_nsdd

	call	setup_nsdd
	call	wakeup_nsdd
.no_nsdd:

	pop	es
	ret

;------------------------------------------------------------------------------
;NSDhCõZN^쐬
;------------------------------------------------------------------------------
	align	4
setup_nsdd:
	mov	ax, 250dh
	int	21h			; call buffer擾

	mov	edi, [work_adr]
	; src es:edx
	; des ds:edi
.loop:
	mov	eax, [es:edx+00h]
	test	eax, eax
	jz	.exit

	mov	ebx, [es:edx+04h]
	mov	ecx, [es:edx+08h]
	mov	esi, [es:edx+0ch]
	mov	[edi+00h], ebx
	mov	[edi+04h], ecx
	mov	[edi+08h], esi

	call	make_mems	; sel=eax, data=[edi]
	add	edx, 10h

	jmp	short .loop
.exit:
	ret

;------------------------------------------------------------------------------
;NSDhCo wake up 
;------------------------------------------------------------------------------
	align	4
wakeup_nsdd:
	mov	esi, offset nsdd_selectors
	mov	edi, [work_adr]
	lea	ebx, [edi + 10h]
	mov	eax, F386_ds
	mov	es, ax
.loop:
	movzx	eax, w [esi]
	test	eax, eax
	jz	.exit

	mov	gs, eax
	mov	[edi+04h], eax
	mov	[edi+0ch], eax
	movzx	eax, w [gs:NSDD_intr_adr]	; +06h  interrupt entry
	movzx	ecx, w [gs:NSDD_stra_adr]	; +08h  strategy  entry
	mov	[edi  ], eax
	mov	[edi+8], ecx

	; call strategy
	;	es:ebx = nsd_data_regist
	push	esi

	push	ebx
	push	edi
	callf	[edi+8]
	pop	edi
	pop	ebx

	; call interrupt /wakeup
	mov	b [ebx+2], NSDD_wakeup
	push	ebx
	push	edi
	callf	[edi]
	pop	edi
	pop	ebx

	pop	esi

	add	esi, 2
	jmp	short .loop
.exit:
	ret

;------------------------------------------------------------------------------
;NSDhCo sleep 
;------------------------------------------------------------------------------
	align	4
sleep_nsdd:
	mov	esi, offset nsdd_selectors
	mov	edi, [work_adr]
	lea	ebx, [edi + 10h]

	;Ōォ珇ԂsleepB
	;nsdd sleepCPUG[N薳[vɂȂ邱Ƃ̂
.find_end:
	add	esi, byte 2
	movzx	eax, w [esi]
	test	eax, eax
	jnz	.find_end

.loop:
	sub	esi, byte 2
	movzx	eax, w [esi]
	test	eax, eax
	jz	.exit

	mov	w [esi], 0	; 2xsleepȂ[u

	push	es
	mov	es, eax
	mov	[edi+4], eax
	movzx	ecx, w [es:NSDD_intr_adr]	; interrupt entry
	mov	[edi], ecx
	pop	es

	; call init/wakeup
	push	ebx
	push	edi
	push	esi
	mov	b [ebx+2], NSDD_sleep
	callf	[edi]
	pop	esi
	pop	edi
	pop	ebx

	jmp	short .loop
.exit:
	ret

;------------------------------------------------------------------------------
;TOWNS  C-MOS dword ǂݏo
;------------------------------------------------------------------------------
	align	4
TOWNS_CMOS_READ:
	add	edx,byte 6	;+3 byte ̈ʒu
	in	al,dx		;(C-MOS ͋ԒnɒĂ)
	mov	bh,al
	sub	edx,byte 2

	in	al,dx		;+2 byte ̈ʒu
	mov	bl,al
	sub	edx,byte 2

	shl	ebx,16

	in	al,dx		;+1 byte ̈ʒu
	mov	bh,al
	sub	edx,byte 2

	in	al,dx		;+0 byte / wԒn
	mov	bl,al
	ret


;==============================================================================
;TOWNS ̏I
;==============================================================================
	align	4
end_TOWNS:
	;------------------------------------------
	;NSDD I
	;------------------------------------------
	cmp	b [nsdd_load], 0
	jz	short .no_nsdd

	call	sleep_nsdd		;NSDhCo~
.no_nsdd:

	;--------------------------------------------------------
	;ʂ̏
	;--------------------------------------------------------
	mov	al,[reset_CRTC]		;reset / 1 = , 2 = CRTĈ
	test	al,al			;0 ?   / 3 = F
	jz	near .no_reset		;ȂΏ

	;*** CRTC ̏ ***
	cmp	al,3			;F ?
	jne	.res_c			; łȂ jmp

	;*** VRAMĂH ***
	; Emulator not set segment access bit
	push	es
	mov	ebx, 128h
	mov	es, bx
	mov	ebx, 07fffch
	cmp	d [es:ebx], 011011011h
	mov	d [es:ebx], 0
	pop	es
	mov	bl, 1
	jne	.res_c

	mov	edi,[GDT_adr]		;GDT AhX[h
	mov	esi,[LDT_adr]		;LDT AhX[h
	mov	 al,[edi + TBIOS_cs +5]	;^CvtB[h[h
	mov	 bl,[esi + 120h   +5]	;GDT:VRAM (16/32k)
	or	 bl,[esi + 128h   +5]	;GDT:VRAM (256)
	or	 bl,[esi + 104h-4 +5]	;LDT:VRAM (16/32k)
	or	 bl,[esi + 10ch-4 +5]	;LDT:VRAM (256)
	or	al,bl
	test	al,01			;ANZX ?
	jz	.no_reset_CRTC		;0 Ȃ T-BIOS gp (jmp)
.res_c:
	push	ebx
	call	TOWNS_DOS_CRTC_init	;CRTC 
	pop	ebx

.no_reset_CRTC:

	;*** VRAM ̏ ***
	mov	al,[reset_CRTC]
	cmp	al,2			;VRAM ͏Ȃ ?
	je	.no_reset_VRAM		; jmp
	cmp	al,1			;K ?
	je	.res_v			; jmp

	test	bl,01			;VRAM ANZX ?
	jz	.no_reset_VRAM		;0 Ȃ VRAM gp (jmp)

.res_v:	push	es
	mov	eax,120h		;VRAM ZN^
	mov	 es,eax			;Load
	xor	edi,edi			;edi = 0
	mov	ecx,512*1024 / 4	;512 KB
	xor	eax,eax			;hԂl
	rep	stosd			;0 NA
	pop	es
.no_reset_VRAM:
.no_reset:

	;///////////////////////////////
	;Key-BIOS̏
	;///////////////////////////////
%if (INIT_KEY_BIOS)
	mov	ah,90h
	int	90h
	mov	ax,0501h
	int	90h
%endif

	ret

;------------------------------------------------------------------------------
;CRTC 
;------------------------------------------------------------------------------
;	Special thanks to 肤 (CRTCf[^)
;
	align	4
TOWNS_DOS_CRTC_init:
	;///////////////////////////////
	;/// ʏooff ///////////////
	mov	dx,0FDA0h	;o͐䃌WX^
	xor	al,al		;al
	;out	dx,al		;ʏooff

	;///////////////////////////////
	;/// CRTC WX^̑ ///////
	mov	ebx,offset TOWNS_CRTC_data
	xor	ecx,ecx
	mov	dh,4h		;CRTC WX^̏ʃrbg

	align	4
.loop1:
	mov	dl,40h		;CRTC AhXWX^ (dx=440h)
	mov	al,cl		;AhXԍ
	out	dx,al		;AhXo
	inc	cl		;AhXXV

	mov	dl,42h		;CRTC f[^WX^ (dx=442h)
	mov	ax,[ebx]	;e[uo͒lǂݏo
	out	dx,ax		;word o
	add	ebx,byte 2	;AhXXV

	cmp	cl,20h		;Il ?
	jne	.loop1

	;///////////////////////////////
	;/// CRTC o̓WX^̑ ///
	mov	dl,48h		;CRTC o̓WX^ER}h (dx=448h)
	mov	al,00h		;AhX = 0
	out	dx,al
	mov	dl,4ah		;CRTC o̓WX^Ef[^ (dx=44ah)
	mov	al,15h		;R}h = 15h
	out	dx,al

	mov	dl,48h		;CRTC o̓WX^ER}h (dx=448h)
	mov	al,01h		;AhX = 1
	out	dx,al
	mov	dl,4ah		;CRTC o̓WX^Ef[^ (dx=44ah)
	mov	al,09h		;R}h = 09h
	out	dx,al		;

	;///////////////////////////////
	;/// pbg̐ݒ ////////////
	mov	ah,08h				;Layer 0
	mov	ebx, offset TOWNS_PAL_layer0	;pbgf[^
	call	.setPalette16

	mov	ah,28h				;Layer 1
	mov	ebx, offset TOWNS_PAL_layer1	;pbgf[^
	call	.setPalette16

	;///////////////////////////////
	;/// FM-R݊o͂̐ݒ ////////
	mov	dx,0ff81h	;FM-R display I/O
	mov	al,0fh
	out	dx,al

	mov	dl,82h		;dx = ff82h
	mov	al,67h
	out	dx,al

	mov	dx,458h		;
	xor	al,al		;al = 0
	out	dx,al
	mov	dl,5ah
	mov	eax,0ffffffffh	
	out	dx,eax

	mov	dx,458h		;
	mov	al,1		;al = 1
	out	dx,al
	mov	dl,5ah
	mov	eax,0ffffffffh	
	out	dx,eax

	;///////////////////////////////
	;/// ʏoon ////////////////
	mov	dx,0FDA0h	;o͐䃌WX^
	mov	al,0fh		;bit 3,2 = layer0 / bit 1,0 = layer1
	;out	dx,al		;ʏooff

	;///////////////////////////////
	;/// FM^C}X^[g ////
	;{ inp(4d8h) & 80h  busy mFׂȂ̂cc
	;
	mov	dx,04d8h	;FMAhXWX^
	mov	al,2bh		;AhX
	out	dx,al		;f[^o
	out	6ch,al		;1us-Wait
	mov	dl,0dah		;FMf[^WX^
	mov	al,2ah		;o͒l
	out	dx,al		;f[^o
	out	6ch,al		;1us-Wait

	mov	dl,0d8h		;FMAhXWX^
	mov	al,27h		;AhX
	out	dx,al		;f[^o
	out	6ch,al		;1us-Wait
	mov	dl,0dah		;FMf[^WX^
	mov	al,2ah		;o͒l
	out	dx,al		;f[^o
	ret

	;/////////////////////////////////////////////////////////////
	;pbgݒ胋[`
	;/////////////////////////////////////////////////////////////
	align	4
.setPalette16:
	mov	dx,448h		;CRTCo̓WX^
	mov	al,01h		;
	out	dx,al		;y[W̐ݒ

	mov	dl,4ah		;CRTCo̓WX^
	mov	al,ah		;y[W̃[h
	out	dx,al		;

	xor	ecx,ecx		;ecx = 0
	mov	dh,0fdh		;pbgWX^̏ʃrbg

	align	4
.loop2:
	mov	al,cl		;pbgԍ
	mov	dl,90h		;
	out	dx,al

	inc	cl		;pbgԍXV
	mov	si,[ebx]	;pbgf[^[h
	add	ebx,byte 2	;AhXXV

	mov	eax,esi		;pbgf[^
	shl	eax,4		;
	mov	dl,92h		;blue
	out	dx,al

	mov	eax,esi		;pbgf[^
	mov	dl,94h		;Red
	out	dx,al		;

	shr	eax,4		;
	mov	dl,96h		;Green
	out	dx,al		;

	cmp	cl,10h		;Il ?
	jne	.loop2
	ret


;==============================================================================
;f[^̈
;==============================================================================
nsdd_load	db	1

;==============================================================================
;CRTC e[u
;==============================================================================
	align	4
TOWNS_CRTC_data:
	;// 24kHz[h 640~400(4bits,FMR)+640~400(4bits)
	dw	0040h, 0320h, 0000h, 0000h, 035fh, 0000h, 0010h, 0000h
	dw	036fh, 009ch, 031ch, 009ch, 031ch, 0040h, 0360h, 0040h
	dw	0360h, 0000h, 009ch, 0000h, 0050h, 0000h, 009ch, 0000h
	dw	0080h, 004ah, 0001h, 0000h, 803fh, 0003h, 0000h, 0188h

	;pbgf[^
TOWNS_PAL_layer0:	;OtBbNʁiOj
	dw	0000h, 0008h, 0080h, 0088h, 0800h, 0808h, 0880h, 0888h
	dw	0777h, 000fh, 00f0h, 00ffh, 0f00h, 0f0fh, 0ff0h, 0fffh
TOWNS_PAL_layer1:	;R\[ () 
	dw	0000h, 000bh, 00b0h, 00bbh, 0b00h, 0b0bh, 0bb0h, 0bbbh
	dw	0888h, 000fh, 00f0h, 00ffh, 0f00h, 0f0fh, 0ff0h, 0fffh

;==============================================================================
;CoCo/NSDD֘Af[^
;==============================================================================
	align	4
	dw	0		;tɂǂ邱Ƃ̂ł̎̏I}[N
nsdd_selectors:
	times	(NSDD_max)	dw	0
	dw	0		;I}[N

;==============================================================================
;T-OS ̃֘Af[^
;==============================================================================
	align	4
T_OS_memory_map:
		;sel, base     ,  pages -1, type/level
	dd	100h,0fffc0000h,  256/4 -1, 0a00h	;R/X : boot-ROM
	;dd	108h,0fffc0000h,  256/4 -1, 0000h	;R   : boot-ROM
	dd	120h, 80000000h,  512/4 -1, 0200h	;R/W : VRAM (16/32k)
	dd	128h, 80100000h,  512/4 -1, 0200h	;R/W : VRAM (256)
	dd	130h, 81000000h,  128/4 -1, 0200h	;R/W : Sprite-RAM
	dd	138h,0c2100000h,  264/4 -1, 0200h	;R/W : FONT-ROM,wKRAM
	dd	140h,0c2200000h,    4/4 -1, 0200h	;R/W : Wave-RAM
	dd	148h,0c2000000h,  512/4 -1, 0000h	;R   : OS-ROM
	dd	11ch, 82000000h, 1024/4 -1, 0200h	;R/W : H-VRAM / 2 layer
	dd	124h, 83000000h, 1024/4 -1, 0200h	;R/W : H-VRAM / 1 layer
	;dd	12ch, 84000000h,  1000h -1, 0200h	;R/W : ??? (H-CURSOR?)
	dd	0	;end of data			;T-OS L51ŊmF

	align	4
T_OS_memory_map_386sx:
		;sel, base     ,  pages -1, type/level
	dd	100h, 00fc0000h,  256/4 -1, 0a00h	;R/X : boot-ROM
	;dd	108h, 00fc0000h,  256/4 -1, 0000h	;R   : boot-ROM
	dd	120h, 00a00000h,  512/4 -1, 0200h	;R/W : VRAM (16/32k)
	dd	128h, 00b00000h,  512/4 -1, 0200h	;R/W : VRAM (256)
	dd	130h, 00c00000h,  128/4 -1, 0200h	;R/W : Sprite-RAM
	dd	138h, 00f00000h,  264/4 -1, 0200h	;R/W : FONT-ROM,wKRAM
	dd	140h, 00f80000h,    4/4 -1, 0200h	;R/W : Wave-RAM
	dd	148h, 00e00000h,  512/4 -1, 0000h	;R   : OS-ROM
	dd	0	;end of data			;T-OS L51ŊmF

	align	4
T_OS_selector_alias:
		;ORG, alias, type/level
	dd	100h,  108h,  0000h	;boot-ROM
	dd	120h,  104h,  0200h	;VRAM (16/32k)
	dd	128h,  10ch,  0200h	;VRAM (256)
	dd	130h,  114h,  0200h	;Sprite-RAM

	dd	120h,   48h,  0200h	;s alias / VRAM(16/32K)
	dd	120h,   1ch,  0200h	;s alias / VRAM(16/32K)
	dd	0	;end of data


segment	code
